<?php

namespace ShopWP\API\Storefront;

if (!defined('ABSPATH')) {
	exit;
}

class Collections {

   public $GraphQL;
   public $Storefront_Queries;
   
   public function __construct($GraphQL, $Storefront_Queries) {
      $this->GraphQL = $GraphQL;
		$this->Storefront_Queries = $Storefront_Queries;
   }
   
   public function api_get_collections($query_params, $custom_schema = false, $with_products = false) {

      $query = $this->Storefront_Queries->query_get_collections($query_params, $custom_schema, $with_products);

      return $this->GraphQL->graphql_api_request(
         $query,
         'storefront',
         [
            'mutation_key' => false,
            'data_key' => 'collections', 
            'user_errors_key' => 'userErrors'
         ]
      );
   }  

}