<?php

namespace ShopWP;

if (!defined('ABSPATH')) {
    exit();
}

use ShopWP\Factories;
use ShopWP\Utils;

class Bootstrap
{

    public static $_instance = null;

	public static function instance() {
		
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}

		return self::$_instance;
        
	}
    
    public function __construct()
    {

        $this->build_plugin();

    }

    public function build_plugin()
    {

        $plugin_settings                                = Factories\DB\Settings_Plugin_Factory::build();
        $permalinks                                     = Utils::get_permalinks();
        
        $results['CPT']                                 = Factories\CPT_Factory::build($plugin_settings)->init($permalinks);
        $results['Deactivator']                         = Factories\Deactivator_Factory::build($plugin_settings)->init();
        $results['Updater']                             = Factories\Updater_Factory::build($plugin_settings)->init();
        $results['Frontend']                            = Factories\Frontend_Factory::build($plugin_settings)->init();
        $results['Backend']                             = Factories\Backend_Factory::build($plugin_settings)->init();
        $results['Admin_Menus']                         = Factories\Admin_Menus_Factory::build($plugin_settings)->init();
        $results['Templates']                           = Factories\Templates_Factory::build($plugin_settings)->init();
        $results['I18N']                                = Factories\I18N_Factory::build($plugin_settings)->init();
        $results['Shortcodes']                          = Factories\Shortcodes\Shortcodes_Factory::build($plugin_settings)->init();
        $results['API_Items_Products_Factory']          = Factories\API\Items\Products_Factory::build($plugin_settings)->init();
        $results['API_Items_Orders_Factory']            = Factories\API\Items\Orders_Factory::build($plugin_settings)->init();
        $results['API_Items_Shop_Factory']              = Factories\API\Items\Shop_Factory::build($plugin_settings)->init();
        $results['API_Options_Components_Factory']      = Factories\API\Options\Components_Factory::build($plugin_settings)->init();
        $results['API_Items_Cart_Factory']              = Factories\API\Items\Cart_Factory::build($plugin_settings)->init();
        $results['API_Settings_Collections_Factory']    = Factories\API\Settings\Collections_Factory::build($plugin_settings)->init();
        $results['API_Settings_License_Factory']        = Factories\API\Settings\License_Factory::build($plugin_settings)->init();
        $results['API_Settings_General_Factory']        = Factories\API\Settings\General_Factory::build($plugin_settings)->init();
        $results['API_Settings_Connection_Factory']     = Factories\API\Settings\Connection_Factory::build($plugin_settings)->init();
        $results['API_Status_Factory']                  = Factories\API\Syncing\Status_Factory::build($plugin_settings)->init();
        $results['API_Indicator_Factory']               = Factories\API\Syncing\Indicator_Factory::build($plugin_settings)->init();
        $results['API_Items_Collections_Factory']       = Factories\API\Items\Collections_Factory::build($plugin_settings)->init();
        $results['API_Misc_Notices_Factory']            = Factories\API\Misc\Notices_Factory::build($plugin_settings)->init();
        $results['API_Tools_Cache_Factory']             = Factories\API\Tools\Cache_Factory::build($plugin_settings)->init();
        $results['Processing_Items']                    = Factories\Processing\Items_Factory::build($plugin_settings)->init();
        $results['Webhooks']                            = Factories\Webhooks_Factory::build($plugin_settings);
        
        do_action('shopwp_is_ready');

        return $results;

    }

}

Bootstrap::instance();