<?php

namespace ShopWP;

use ShopWP\Utils;


if (!defined('ABSPATH')) {
    exit();
}

class Data
{

    public $plugin_settings;
    public $DB_Collections;
    public $DB_Collects;
    public $DB_Customers;
    public $DB_Images;
    public $DB_Metafields;
    public $DB_Options;
    public $DB_Orders;
    public $DB_Products;
    public $DB_Shop;
    public $DB_Tags;
    public $DB_Variants;

    public function __construct($plugin_settings, $DB_Collections, $DB_Collects, $DB_Customers, $DB_Images, $DB_Metafields, $DB_Options, $DB_Orders, $DB_Products, $DB_Shop, $DB_Tags, $DB_Variants)
    {
        $this->plugin_settings      = $plugin_settings;
        $this->DB_Collections       = $DB_Collections;
        $this->DB_Collects          = $DB_Collects;
        $this->DB_Customers         = $DB_Customers;
        $this->DB_Images            = $DB_Images;
        $this->DB_Metafields        = $DB_Metafields;
        $this->DB_Options           = $DB_Options;
        $this->DB_Orders            = $DB_Orders;
        $this->DB_Products          = $DB_Products;
        $this->DB_Shop              = $DB_Shop;
        $this->DB_Tags              = $DB_Tags;
        $this->DB_Variants          = $DB_Variants;
    }

    public function get_product($post_id) {

        if (empty($post_id)) {
            return Utils::wp_error(__('No post ID provided', 'shopwp'));
        }

        $product_data = $this->DB_Products->get_product($post_id);

        if (empty($product_data)) {
            return Utils::wp_error(__('No product found with the post ID: ', 'shopwp') . $post_id . __('. Try re-syncing your Shopify store.', 'shopwp'));
        }

        $product_data->tags             = $this->DB_Tags->get_tags_from_product_id($product_data->productId);
        $product_data->images           = $this->DB_Images->get_images_from_product_id($product_data->productId);
        $product_data->options          = $this->DB_Options->get_options_from_product_id($product_data->productId);
        $product_data->variants         = $this->DB_Variants->unserialize_variants($this->DB_Variants->get_variants_from_product_id($product_data->productId));

        $product_data->seo              = maybe_unserialize($product_data->seo);
        $product_data->priceRangeV2     = maybe_unserialize($product_data->priceRangeV2);
        $product_data->featuredImage    = maybe_unserialize($product_data->featuredImage);
        $product_data->options          = $this->DB_Options->unserialize_options($product_data->options);

        return $product_data;

    }

}