<?php

namespace ShopWP;

if (!defined('ABSPATH')) {
    exit();
}

class Deactivator
{
    public $Compatibility;
    
    public function __construct($Compatibility)
    {
        $this->Compatibility = $Compatibility;
    }

    public function on_plugin_deactivate()
    {
        unregister_post_type(SHOPWP_PRODUCTS_POST_TYPE_SLUG);
        unregister_post_type(SHOPWP_COLLECTIONS_POST_TYPE_SLUG);

        $this->Compatibility->delete_compatibility_mu();

        $timestamp1 = wp_next_scheduled( 'shopwp_bulk_recheck_cron_hook' );
        $timestamp2 = wp_next_scheduled( 'shopwp_auto_sync_cron_callback' );

        $unschedule_result1 =  \wp_unschedule_event( $timestamp1, 'shopwp_bulk_recheck_cron_hook' );
        $unschedule_result2 =  \wp_unschedule_event( $timestamp2, 'shopwp_auto_sync_cron_callback' );

        \wp_clear_scheduled_hook('shopwp_bulk_recheck_cron_hook');
        \wp_clear_scheduled_hook('shopwp_auto_sync_cron_callback');
    }

    public function init()
    {
        add_action('shopwp_on_plugin_deactivate', [$this, 'on_plugin_deactivate']);
    }
}
