<?php

namespace ShopWP\Factories\API\Admin\Webhooks;

use ShopWP\Factories;
use ShopWP\API;

defined('ABSPATH') ?: die();

class Webhooks_Factory
{
    protected static $instantiated = null;

    public static function build($plugin_settings = false)
    {
        if (is_null(self::$instantiated)) {
            self::$instantiated = new API\Admin\Webhooks\Webhooks(
                Factories\API\GraphQL_Factory::build($plugin_settings),
                Factories\API\Admin\Webhooks\Queries_Factory::build(),
                Factories\DB\Settings_Syncing_Factory::build(),
                Factories\DB\Settings_General_Factory::build(),
            );
        }

        return self::$instantiated;
    }
}