<?php

namespace ShopWP\Factories\API\Items;

defined('ABSPATH') ?: die();

use ShopWP\API;
use ShopWP\Factories;

class Products_Factory
{
    protected static $instantiated = null;

    public static function build($plugin_settings = false)
    {
        if (!$plugin_settings) {
            $plugin_settings = Factories\DB\Settings_Plugin_Factory::build();
        }
                
        if (is_null(self::$instantiated)) {
            self::$instantiated = new API\Items\Products(
                Factories\DB\Settings_General_Factory::build(),
                Factories\DB\Settings_Syncing_Factory::build(),
                Factories\DB\Settings_Connection_Factory::build(),
                Factories\DB\Metafields_Factory::build(),
                Factories\Shopify_API_Factory::build(),
                Factories\Processing\Database_Factory::build($plugin_settings),
                Factories\API\Admin\Shop\Shop_Factory::build(),
                Factories\API\Storefront\Products\Products_Factory::build($plugin_settings),
                Factories\API\Items\Collections_Factory::build(),
                Factories\API\Admin\Webhooks\Webhooks_Factory::build(),
                Factories\API\Admin\Webhooks\Queries_Factory::build(),
                Factories\Filesystem\Filesystem_Factory::build(),
                Factories\Processing\Media_Factory::build($plugin_settings),
                Factories\Data_Bridge_Factory::build($plugin_settings)
            );
        }

        return self::$instantiated;
    }
}
