<?php

namespace ShopWP\Factories;

use ShopWP\Data;
use ShopWP\Factories;

if (!defined('ABSPATH')) {
    exit();
}

class Data_Factory
{
    protected static $instantiated = null;

    public static function build($plugin_settings = false)
    {
        if (is_null(self::$instantiated)) {
            $Data = new Data(
                $plugin_settings,
                Factories\DB\Collections_Factory::build(),
                Factories\DB\Collects_Factory::build(),
                Factories\DB\Customers_Factory::build(),
                Factories\DB\Images_Factory::build(),
                Factories\DB\Metafields_Factory::build(),
                Factories\DB\Options_Factory::build(),
                Factories\DB\Orders_Factory::build(),
                Factories\DB\Products_Factory::build(),
                Factories\DB\Shop_Factory::build(),
                Factories\DB\Tags_Factory::build(),
                Factories\DB\Variants_Factory::build(),
            );

            self::$instantiated = $Data;
        }

        return self::$instantiated;
    }
}