<?php

namespace ShopWP\Factories\Processing;

use ShopWP\Processing;
use ShopWP\Factories;
use ShopWP\API;

defined('ABSPATH') ?: die();

class Items_Factory
{

    protected static $instantiated = null;

    public static function build($plugin_settings = false)
    {

        if (!$plugin_settings) {
            $plugin_settings = Factories\DB\Settings_Plugin_Factory::build();
        }
                
        if (is_null(self::$instantiated)) {
            self::$instantiated = new Processing\Items(
                Factories\DB\Settings_Syncing_Factory::build(),
                Factories\DB\Settings_General_Factory::build(),
                Factories\DB\Products_Factory::build(),
                Factories\DB\Collections_Factory::build(),
                Factories\DB\Images_Factory::build(),
                Factories\DB\Metafields_Factory::build(),
                Factories\DB\Options_Factory::build(),
                Factories\DB\Variants_Factory::build(),
                Factories\DB\Tags_Factory::build(),
                Factories\DB\Customers_Factory::build(),
                Factories\DB\Orders_Factory::build(),
                Factories\CPT_Model_Factory::build(),
                Factories\Media_Uploader_Factory::build()
            );
        }

        return self::$instantiated;
    }
}
