<?php

namespace ShopWP\Factories\Processing;

use ShopWP\Processing;
use ShopWP\Factories;

if (!defined('ABSPATH')) {
    exit();
}

class Media_Factory
{
    protected static $instantiated = null;

    public static function build($plugin_settings = false)
    {
        if (is_null(self::$instantiated)) {
            
            $Async_Processing_Media = new Processing\Media(
                Factories\Config_Factory::build(),
                Factories\DB\Settings_Connection_Factory::build(),
                Factories\DB\Settings_General_Factory::build(),
                Factories\DB\Settings_Syncing_Factory::build(),
                Factories\DB\Images_Factory::build()
            );

            self::$instantiated = $Async_Processing_Media;
        }

        return self::$instantiated;
    }
}
