<?php

/*

Plugin Name:         ShopWP Pro
Plugin URI:          https://wpshop.io
Description:         Sell and build custom Shopify experiences on WordPress.
Version:             8.6.1
Author:              ShopWP
Author URI:          https://wpshop.io
License:             GPL-2.0+
License URI:         https://www.gnu.org/licenses/gpl-2.0.txt
Text Domain:         shopwp
Domain Path:         /languages
Requires at least:   5.4
Requires PHP:        5.6

*/
global $ShopWP;

require_once ABSPATH . 'wp-admin/includes/plugin.php';

// If this file is called directly, abort.
defined('WPINC') ?: die();

// If this file is called directly, abort.
defined('ABSPATH') ?: die();

// Deactivate free version if activated
if (in_array('wpshopify/shopwp.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    \deactivate_plugins( 'wpshopify/shopwp.php' );
}

// Used for both free / pro versions
if (!defined('SHOPWP_BASENAME')) {
    define('SHOPWP_BASENAME', plugin_basename(__FILE__));
}

if (!defined('SHOPWP_ROOT_FILE_PATH')) {
    define('SHOPWP_ROOT_FILE_PATH', __FILE__);
}

if (!defined('SHOPWP_PLUGIN_DIR')) {
    define('SHOPWP_PLUGIN_DIR', plugin_dir_path(__FILE__));
}

require_once plugin_dir_path(__FILE__) . 'vendor/autoload.php';

\ShopWP\Factories\Config_Factory::build()->init();
\ShopWP\Factories\Activator_Factory::build()->init();

final class ShopWP {

    public function __construct() {
		add_action('init', [$this, 'init']);
	}

	public function init() {
		require_once( dirname(__FILE__) . '/classes/class-bootstrap.php' );
	}

}

new ShopWP();

/*

Adds hooks which run on both plugin activation and deactivation.
The actions here are added during Activator->init() and Deactivator-init().

*/
register_activation_hook(__FILE__, function ($network_wide) {
    \ShopWP\Factories\Activator_Factory::build()->on_plugin_activate($network_wide);
});

register_deactivation_hook(__FILE__, function () {
    do_action('shopwp_on_plugin_deactivate');
});

add_action('admin_footer', function () {
    echo '<style>a[href="admin.php?page=wps-license"] {display:block;margin-top: 9px !important;border-top: 1px solid hsla(0, 0%, 100%, 0.2);padding-top: 10px !important;}</style>';
});